'Modded by Alex Erlank to add logging
'
'Takes a Screenshot of VGA screen and saves it to SD card as Windows .BMP picture file

'Copyright 2007 Raymond Allen

'  PrintScreen.SaveBMP(0, @screen, vga_colorbase, cols, rows)     '(SD_BasePin, pscreen, pvga_colorbase, ncols, nrows)

OBJ
    sdfat: "fsrw"

PUB  SaveBMP(SD_BasePin, pscreen,pvga_colorbase,ncols,nrows)|i,j,x,y,b1,b2,b3,xtile,ytile, ptile, pcolor, line, pixel, n ,pixelc, color3, ppic,jj
  'Save VGA screen as BMP on SD card
  'VGA is colsxrows of 16x16 (x4 color) tiles 
'  pvga_colorbase := @vgacolors

  sFsame++                           ' change filename (beware only 0-9...)

  sdfat.mount(SD_BasePin)
  sdfat.setdate(2011, 6,     12,  10,   19,      30)
  sdfat.popen(@sFilename, "w")

  'First, write the header 
  biWidth:=ncols*4
  biHeight:=nrows'*16
  bfSize:=biWidth*biHeight*3*4+54
  sdfat.pwrite(@bfType,2)
  sdfat.pwrite(@bfSize,4)   
  sdfat.pwrite(@bfReserved1,2)   
  sdfat.pwrite(@bfReserved2,2)   
  sdfat.pwrite(@bfOffBits,4)   
  sdfat.pwrite(@biSize,4)   
  sdfat.pwrite(@biWidth,4)   
  sdfat.pwrite(@biHeight,4)   
  sdfat.pwrite(@biPlanes,2)   
  sdfat.pwrite(@biBitCount,2)   
  sdfat.pwrite(@biCompression,4)   
  sdfat.pwrite(@biSizeImage,4)   
  sdfat.pwrite(@biXPelsPerMeter,4)   
  sdfat.pwrite(@biYPelsPerMeter,4)
  sdfat.pwrite(@biClrUsed,4)   
  sdfat.pwrite(@biClrImportant,4)  

  'next, spit out 24-bit color pixels (in reverse order) 
  repeat y from biHeight-1 to 0 
      'vertical line loop
      repeat i from 0 to ncols-1 
        'horizontal tile loop  
        xtile:=i
        ytile:=y
        ptile:=byte[pscreen+(ytile * ncols + xtile)]  'ptile points to 16x16x4 color character + color info
        r:=g:=b:=ptile
        repeat 4
          sdfat.pwrite(@RGB,3)

  sdfat.pclose

  sdfat.unmount


PUB  LogGPS(SD_BasePin, data)
  'add an entry to the log file called log.txt, containing the string data

  sdfat.mount(SD_BasePin)
  sdfat.setdate(2011, 6,     12,  10,   19,      30)
  sdfat.popen(string("log.txt"), "a")

  sdfat.pputs(data)

  sdfat.pclose
  sdfat.unmount

PUB  LogGPSNewLine(SD_BasePin)
  'add an entry to the log file called log.txt, containing the string data

  sdfat.mount(SD_BasePin)
  sdfat.setdate(2011, 6,     12,  10,   19,      30)
  sdfat.popen(string("log.txt"), "a")

  sdfat.pputc(13)
  sdfat.pputc(10) 

  sdfat.pclose
  sdfat.unmount

PUB  LogTemperature(SD_BasePin, data)
  'add an entry to the log file called log.txt, containing the string data

  sdfat.mount(SD_BasePin)
  sdfat.setdate(2011, 6,     12,  10,   19,      30)
  sdfat.popen(string("temperature.txt"), "a")

  sdfat.pputs(data)

  sdfat.pclose
  sdfat.unmount

PUB  LogTemperatureNewLine(SD_BasePin)
  'add an entry to the log file called log.txt, containing the string data

  sdfat.mount(SD_BasePin)
  sdfat.setdate(2011, 6,     12,  10,   19,      30)
  sdfat.popen(string("temperature.txt"), "a")

  sdfat.pputc(13)
  sdfat.pputc(10) 

  sdfat.pclose
  sdfat.unmount

DAT
RGB byte
b byte 0
g byte 0
r byte 0 

BMPHeader  'Mostly using info from here:  http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
bfType byte "B","M"  ' 19778
bfSize long 0
bfReserved1 word 0
bfReserved2 word 0
bfOffBits long 54
biSize long 40
biWidth long 0
biHeight long 0
biPlanes word 1
biBitCount word 24
biCompression long 0
biSizeImage long 0
biXPelsPerMeter long 0
biYPelsPerMeter long 0
biClrUsed long 0
biClrImportant long 0

sFilename   byte "PIXL_"         '********   SPECIFY Video Filename HERE   *****************
sFsame      byte "a00.BMP",0       '********   SPECIFY Video Filename HERE   *****************
